import .connectives
import .leibniz
import .logic
axiom nat.nat : Type.
constant nat.O : nat.nat.
constant nat.filter_nat_type : forall (return : Type) , ((nat.nat) -> return) -> (nat.nat) -> return.
axiom nat.axiom_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((connectives.equal) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )).
theorem nat.eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@connectives.equal_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.axiom_filter_nat_type_O) (return_type)) (return)).
theorem nat.sym_eq_filter_nat_type_O : forall (return_type : Type) , forall (return:(nat.nat) -> return_type) , (((leibniz.leibniz) (return_type)) ((return) ((nat.O) ))) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) )) := fun (return_type : Type) , fun (return : (nat.nat) -> return_type) , ((((@leibniz.sym_leibniz) (return_type)) ((((nat.filter_nat_type) (return_type)) (return)) ((nat.O) ))) ((return) ((nat.O) ))) (((@nat.eq_filter_nat_type_O) (return_type)) (return)).
constant nat.times : (nat.nat) -> (nat.nat) -> nat.nat.
constant nat.times_body : (nat.nat) -> (nat.nat) -> nat.nat.
axiom nat.axiom_times : forall (n:nat.nat) , (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)).
theorem nat.eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n)) := fun (n : nat.nat) , ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.axiom_times) (n)).
theorem nat.sym_eq_times : forall (n:nat.nat) , (((leibniz.leibniz) ((nat.nat) -> nat.nat)) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) (((nat.times) ) (n)) := fun (n : nat.nat) , ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times) ) (n))) ((((nat.filter_nat_type) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (n))) ((@nat.eq_times) (n)).
axiom nat.axiom_times_body_O : (((connectives.equal) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) ).
theorem nat.eq_times_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) ) := ((((@connectives.equal_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) )) (@nat.axiom_times_body_O).
theorem nat.sym_eq_times_body_O : (((leibniz.leibniz) ((nat.nat) -> nat.nat)) (fun (m : nat.nat) , (nat.O) )) (((nat.times_body) ) ((nat.O) )) := ((((@leibniz.sym_leibniz) ((nat.nat) -> nat.nat)) (((nat.times_body) ) ((nat.O) ))) (fun (m : nat.nat) , (nat.O) )) (@nat.eq_times_body_O).
theorem nat.times_O_n : forall (n:nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((((nat.times) ) ((nat.O) )) (n)) := fun (n : nat.nat) , (((@nat.sym_eq_times) ((nat.O) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((((@nat.sym_eq_filter_nat_type_O) ((nat.nat) -> nat.nat)) ((nat.times_body) )) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((@nat.sym_eq_times_body_O) (fun (y : (nat.nat) -> nat.nat) , (((logic.eq_) (nat.nat)) ((nat.O) )) ((y) (n)))) (((@logic.refl_) (nat.nat)) ((nat.O) )))).
